// This file was automatically generated. Do not edit this file!
#ifndef INITIALIZER_EXOTICA_CORE_TASK_MAPS_SPHERE_INITIALIZER_H
#define INITIALIZER_EXOTICA_CORE_TASK_MAPS_SPHERE_INITIALIZER_H

#include <exotica_core/property.h>

namespace exotica
{
inline std::vector<Initializer> GetExoticaCoreTaskMapsInitializers();
}

namespace exotica
{

class SphereInitializer : public InitializerBase
{
public:
    static std::string GetContainerName() {return "exotica/Sphere" ;}

    SphereInitializer() : InitializerBase(),
        LinkOffset( Eigen::IdentityTransform()) ,
        Base( "") ,
        BaseOffset( Eigen::IdentityTransform()) ,
        Group( "default") 
    {
    }

    SphereInitializer( std::string _Link, double _Radius, Eigen::VectorXd _LinkOffset =  Eigen::IdentityTransform(), std::string _Base =  "", Eigen::VectorXd _BaseOffset =  Eigen::IdentityTransform(), std::string _Group =  "default") : InitializerBase(),
        Link(_Link) ,
        Radius(_Radius) ,
        LinkOffset(_LinkOffset) ,
        Base(_Base) ,
        BaseOffset(_BaseOffset) ,
        Group(_Group) 
    {
    }

    SphereInitializer(const Initializer& other) : SphereInitializer()
    {
        if (other.HasProperty("Link")) {const Property& prop=other.properties_.at("Link"); if(prop.IsSet()) Link = boost::any_cast<std::string>(prop.Get());}
        if (other.HasProperty("Radius")) {const Property& prop=other.properties_.at("Radius"); if(prop.IsSet()) Radius = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());}
        if (other.HasProperty("LinkOffset")) {const Property& prop=other.properties_.at("LinkOffset"); if(prop.IsSet()) LinkOffset = prop.IsStringType()?ParseVector<double,Eigen::Dynamic>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::VectorXd>(prop.Get());}
        if (other.HasProperty("Base")) {const Property& prop=other.properties_.at("Base"); if(prop.IsSet()) Base = boost::any_cast<std::string>(prop.Get());}
        if (other.HasProperty("BaseOffset")) {const Property& prop=other.properties_.at("BaseOffset"); if(prop.IsSet()) BaseOffset = prop.IsStringType()?ParseVector<double,Eigen::Dynamic>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::VectorXd>(prop.Get());}
        if (other.HasProperty("Group")) {const Property& prop=other.properties_.at("Group"); if(prop.IsSet()) Group = boost::any_cast<std::string>(prop.Get());}
    }

    virtual Initializer GetTemplate() const
    {
        return (Initializer)SphereInitializer();
    }

    virtual std::vector<Initializer> GetAllTemplates() const
    {
        return GetExoticaCoreTaskMapsInitializers();
    }

    virtual void Check(const Initializer& other) const
    {
        if(!other.HasProperty("Link") || !other.properties_.at("Link").IsSet()) ThrowPretty("Initializer SphereInitializer requires property Link to be set!");
        if(!other.HasProperty("Radius") || !other.properties_.at("Radius").IsSet()) ThrowPretty("Initializer SphereInitializer requires property Radius to be set!");
    }

    operator Initializer()
    {
        Initializer ret(GetContainerName());
        ret.properties_.emplace("Link", Property("Link", true, boost::any(Link)));
        ret.properties_.emplace("Radius", Property("Radius", true, boost::any(Radius)));
        ret.properties_.emplace("LinkOffset", Property("LinkOffset", false, boost::any(LinkOffset)));
        ret.properties_.emplace("Base", Property("Base", false, boost::any(Base)));
        ret.properties_.emplace("BaseOffset", Property("BaseOffset", false, boost::any(BaseOffset)));
        ret.properties_.emplace("Group", Property("Group", false, boost::any(Group)));
        return ret;
    }

    std::string Link;
    double Radius;
    Eigen::VectorXd LinkOffset;
    std::string Base;
    Eigen::VectorXd BaseOffset;
    std::string Group;
};

}

#include<exotica_core_task_maps/exotica_core_task_maps_initializers_numerator.h>


#endif